/*	
 *	fram.c
 *
 *	xmplay - wlvC[
 *	Copyright (C) 2002,2003 Naoyuki Sawa
 *
 *	* Wed Feb 12 21:28:00 JST 2003 Naoyuki Sawa
 *	- 쐬JnB
 */
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <limits.h>
#include <piece.h>
#include <s1c33cpu.h>
#include "c33209.h"
#include "_allinc2.h"
#include "_mod.h"

S32 MOD__OutPut_16BitStereo(
	 MOD	*pMOD
	,U32	*pWaveOutPut	/* g`o͐iL R ЂƂ܂Ƃ߂ɂāAU32 Pʂŏo͂j*/
	,S32	 nWaveOutPut	/* o͔g` */
){
	#define	N_MIX	( 256 )

	S32	aMixBuff[ N_MIX * 2 ];	/* ~LVOpe|obt@iL R ݁j*/
	S32	i ;

	/* Ȃ狭I */
	if(	pMOD == NULL
	||	pWaveOutPut == NULL
	) return( FALSE );

	if(	pMOD->FormatType == TYPE_NOTAVAILABLE ) return( FALSE );

	while( nWaveOutPut > 0 ){
		S32	nWaveOutPutSub ;


		/* g` */
		if(	nWaveOutPut >= N_MIX ){
			nWaveOutPutSub = N_MIX ;
		} else {
			nWaveOutPutSub = nWaveOutPut ;
		}
		nWaveOutPut -= nWaveOutPutSub ;


		/* v`mCY΍ */
		for( i=0 ; i<pMOD->XmHeader.NumberOfChannels ; i++ ){
			CHANSTAT	*pCHANSTAT	= &(pMOD->aCHANSTAT[ i ]);

			/* ʁi0_ ` 1_j */
			S32	SampleVolume_L_	= (pCHANSTAT->FinalVolume_L_ >> 6) * pMOD->GainControlScale_ >> SFT ;
			S32	SampleVolume_R_	= (pCHANSTAT->FinalVolume_R_ >> 6) * pMOD->GainControlScale_ >> SFT ;

			/*
				FւĂꍇ
				g`|WVւĂꍇ
				ʂωĂꍇ
			*/
			if(	pCHANSTAT->LastSamplePosition_	 != pCHANSTAT->SamplePosition_
			||	pCHANSTAT->pLastPlayingXM_SAMPLE != pCHANSTAT->pPlayingXM_SAMPLE
			||	pCHANSTAT->LastSampleVolume_L_	 != SampleVolume_L_
			||	pCHANSTAT->LastSampleVolume_R_	 != SampleVolume_R_
			){
				XM_SAMPLE	*pXM_SAMPLE	= pCHANSTAT->pPlayingXM_SAMPLE ;
				S32	NowVal_L	= 0 ;
				S32	NowVal_R	= 0 ;

				if(	pXM_SAMPLE != NULL ){
					U32	SamplePosition_	= pCHANSTAT->SamplePosition_ ;
					U32	SampleLength_	= pXM_SAMPLE->SampleLength << SFT ;
					if(	SamplePosition_ < SampleLength_ ){
						S32	Val	 = 0 ;
						S32	Val0 = 0 ;
						S32	Val1 = 0 ;

						if(	(pXM_SAMPLE->VoiceMode & VM_16BIT) == 0 ){
							S8	*pSampleData = pXM_SAMPLE->pSampleData ;
							if(	pSampleData != NULL ){
								Val0	= (S32)pSampleData[  SamplePosition_ >> SFT ] << 8 ;
								Val1	= (S32)pSampleData[ (SamplePosition_ >> SFT) + 1 ] << 8 ;
							}
						} else {
							S16	*pSampleData = pXM_SAMPLE->pSampleData ;
							if(	pSampleData != NULL ){
								Val0	= (S32)pSampleData[  SamplePosition_ >> SFT ];
								Val1	= (S32)pSampleData[ (SamplePosition_ >> SFT) + 1 ];
							}
						}

						Val			= Val0 + (((Val1 - Val0) * ((S32)SamplePosition_ & DECIMAL)) >> SFT) ;
						NowVal_L	= Val * SampleVolume_L_ >> SFT ;
						NowVal_R	= Val * SampleVolume_R_ >> SFT ;
					}
				}

				pMOD->AntiNoiseVal_L += pCHANSTAT->LastWaveVal_L - NowVal_L ;
				pMOD->AntiNoiseVal_R += pCHANSTAT->LastWaveVal_R - NowVal_R ;
			}
		}


		/* v`mCY΍􂵂Aobt@NA */
		{
			S32	AntiNoiseVal_L = pMOD->AntiNoiseVal_L ;
			S32	AntiNoiseVal_R = pMOD->AntiNoiseVal_R ;

			for( i=0 ; i<nWaveOutPutSub*2 ; i+=2 ){
				aMixBuff[i  ] = AntiNoiseVal_L ;
				aMixBuff[i+1] = AntiNoiseVal_R ;
				AntiNoiseVal_L -= AntiNoiseVal_L >> 6 ;
				AntiNoiseVal_R -= AntiNoiseVal_R >> 6 ;
			}

			pMOD->AntiNoiseVal_L = AntiNoiseVal_L ;
			pMOD->AntiNoiseVal_R = AntiNoiseVal_R ;
		}


		/* `lJԂ */
		for( i=0 ; i<pMOD->XmHeader.NumberOfChannels ; i++ ){
			CHANSTAT	*pCHANSTAT	= &(pMOD->aCHANSTAT[ i ]);
			XM_SAMPLE	*pXM_SAMPLE	= pCHANSTAT->pPlayingXM_SAMPLE ;

			/* ʁi0_ ` 1_j */
			S32	SampleVolume_L_		= (pCHANSTAT->FinalVolume_L_ >> 6) * pMOD->GainControlScale_ >> SFT ;
			S32	SampleVolume_R_		= (pCHANSTAT->FinalVolume_R_ >> 6) * pMOD->GainControlScale_ >> SFT ;

			S32	Val_L	= 0 ;
			S32	Val_R	= 0 ;

			S32	CaseVal = 0 ;

			/* ʂ 0 ̎̂߂̏ꍇivZ덷lĔÂĂj*/
			if(	SampleVolume_L_ < -ONE/128  ||  ONE/128 < SampleVolume_L_ ) CaseVal |= 1 ;
			if(	SampleVolume_R_ < -ONE/128  ||  ONE/128 < SampleVolume_R_ ) CaseVal |= 2 ;

			if(	pXM_SAMPLE != NULL ){
				S32	*pMixBuff			= &(aMixBuff[ 0 ]) ;
				S32	*pMixEnd			= &(aMixBuff[ nWaveOutPutSub * 2 ]) ;
				U32	SampleRate_			= pCHANSTAT->SampleRate_ ;
				U32	SamplePosition_		= pCHANSTAT->SamplePosition_ ;
				U32	SampleLength_		= pXM_SAMPLE->SampleLength << SFT ;
				U32	SampleLoopLength_	= pXM_SAMPLE->SampleLoopLength << SFT ;

				/* `⊮g` */
				if(	pXM_SAMPLE->pSampleData != NULL
				&&	pXM_SAMPLE->VoiceMode & VM_ON
				&&	SampleRate_
				){
					S32	bLoop = ((pXM_SAMPLE->VoiceMode & VM_LOOP) != 0) ;

					/*-------- }N̒`ij--------*/

					#undef	MACRO
					#define	MACRO( _CaseVal_ , _nShift_ )												\
					while( pMixBuff < pMixEnd ){														\
						if(	SamplePosition_ >= SampleLength_ ){											\
							if(	bLoop == FALSE ) break ;												\
							do {																		\
								SamplePosition_ -= SampleLoopLength_ ;									\
							} while( SamplePosition_ >= SampleLength_ );								\
						}																				\
																										\
						if(	_CaseVal_ & 3 ){															\
							S32	Val0 , Val1 , Val ;														\
							Val0 = (S32)pSampleData[  SamplePosition_ >> SFT ];							\
							if(	_nShift_ ) Val0 <<= _nShift_ ;											\
							Val1 = (S32)pSampleData[ (SamplePosition_ >> SFT) + 1 ];					\
							if(	_nShift_ ) Val1 <<= _nShift_ ;											\
							Val = Val0 + (((Val1 - Val0) * ((S32)SamplePosition_ & DECIMAL)) >> SFT) ;	\
							if( _CaseVal_ & 1 ) Val_L = Val * SampleVolume_L_ >> SFT ;					\
							if( _CaseVal_ & 2 ) Val_R = Val * SampleVolume_R_ >> SFT ;					\
							if( _CaseVal_ & 1 ) pMixBuff[0]	+= Val_L ;									\
							if( _CaseVal_ & 2 ) pMixBuff[1]	+= Val_R ;									\
						}																				\
						pMixBuff += 2 ;																	\
						SamplePosition_ += SampleRate_ ;												\
					}																					\

					/*-------- }N̒`i܂Łj--------*/

					if(	(pXM_SAMPLE->VoiceMode & VM_16BIT) == 0 ){
					/* 8 bit sample */
						S8	*pSampleData = (S8*)pXM_SAMPLE->pSampleData ;
						switch( CaseVal ){
							/* L R ƂȂ */
							case 0 :{
								MACRO( 0 , 8 );
							} break ;

							/* L ̂ݏ */
							case 1 :{
								MACRO( 1 , 8 );
							} break ;

							/* R ̂ݏ */
							case 2 :{
								MACRO( 2 , 8 );
							} break ;

							/* L R Ƃ */
							case 3 :{
								MACRO( 3 , 8 );
							} break ;
						}
					} else {
					/* 16 bit sample */
						S16	*pSampleData = (S16*)pXM_SAMPLE->pSampleData ;
						switch( CaseVal ){
							/* L R ƂȂ */
							case 0 :{
								MACRO( 0 , 0 );
							} break ;

							/* L ̂ݏ */
							case 1 :{
								MACRO( 1 , 0 );
							} break ;

							/* R ̂ݏ */
							case 2 :{
								MACRO( 2 , 0 );
							} break ;

							/* L R Ƃ */
							case 3 :{
								MACRO( 3 , 0 );
							} break ;
						}
					}

					pCHANSTAT->SamplePosition_ = SamplePosition_ ;
				}
			}

			/* v`mCY΍p */
			pCHANSTAT->pLastPlayingXM_SAMPLE	= pCHANSTAT->pPlayingXM_SAMPLE ;
			pCHANSTAT->LastSamplePosition_		= pCHANSTAT->SamplePosition_ ;
			pCHANSTAT->LastWaveVal_L			= Val_L ;
			pCHANSTAT->LastWaveVal_R			= Val_R ;
			pCHANSTAT->LastSampleVolume_L_		= SampleVolume_L_ ;
			pCHANSTAT->LastSampleVolume_R_		= SampleVolume_R_ ;
		}


		/* OaAg`o */
		{
			S32	*pMixBuff = &(aMixBuff[0]) ;
			S32	nOver = 0 ;

			while( nWaveOutPutSub > 0 ){
				S32	ValL = pMixBuff[0] ;
				S32	ValR = pMixBuff[1] ;
				pMixBuff += 2 ;

				if(	ValL < -0x7FFF ){ ValL = -0x7FFF ; nOver++ ; }
				if(	ValL >  0x7FFF ){ ValL =  0x7FFF ; nOver++ ; }
				if(	ValR < -0x7FFF ){ ValR = -0x7FFF ; nOver++ ; }
				if(	ValR >  0x7FFF ){ ValR =  0x7FFF ; nOver++ ; }

				*pWaveOutPut = (U32)((ValL & 0xFFFF) | (ValR << 16)) ;

				pWaveOutPut++ ;
				nWaveOutPutSub-- ;
			}

			/* QCRg[ */
			if(	pMOD->bAutoGainControl ){
				if(	nOver > 8 ){
					pMOD->GainControlScale_ -= pMOD->GainControlScale_ >> 8 ;
				} else {
					pMOD->GainControlScale_ += pMOD->GainControlScale_ >> 8 ;
					pMOD->GainControlScale_++ ;
					if(	pMOD->GainControlScale_ > ONE ){
						pMOD->GainControlScale_ = ONE ;
					}
				}
			} else {
				pMOD->GainControlScale_ = ONE ;
			}
		}
	}


	return( TRUE );
}
